#MH algorihtm to simulate GvMF with jumping mixture of vmF

MH_mix <- function(N_s,mu1,mu2,k1,k2,xi){

source("Wood_vMF_mu_Rodrigues.R")
source("sphere_m_unit.R")
source("vMF_mix.R")
# -------------------- #
# -------------------- #

f <- function(x) exp(k1*sum(x*mu1)+k2*(sum(x*mu2)^2))
#A1 <- (k2/2)^(m/2-1)*(1/(gamma(m/2)*besselI(k2,m/2-1))) # normalizing constant of vMF(mu1,k1)
g1 <- function(x) exp(k2*sum(x*mu2)) # density of vMF(mu2,k2)

#A2 <-  (k2/2)^(m/2-1)*(1/(gamma(m/2)*besselI(k2,m/2-1))) # normalizing constant of vMF(mu2,k2)
g2 <- function(x) exp(k2*sum(-x*mu2)) # density of vMF(-mu2,k2)

g <- function(x) xi*g1(x)+(1-xi)*g2(x) # density of the mixture
# -------------------- #


psi <-  matrix(mu2, nrow = N_s, ncol = m, byrow = TRUE)


# -------------------- #

for (i in 2:N_s) {
  Y <- vMF_mix(m,mu1,mu2,k1,k2,xi)
  acc_prob <- min((f(Y)/f(psi[i-1,]))*(g(psi[i-1,])/g(Y)),1)
  if (runif(1) < acc_prob) {psi[i,] <- Y} else {psi[i,]<- psi[i-1,]}
}

return(psi)

}
