
## Algorithm to generate n random vector uniformly distributed on the unit m-dimensional sphere ##

sphere_m_unit <- function(n,m) {
  x <- matrix(NA, n, m)
  for (i in 1:n) {
    x[i,] <- rnorm(m,0,1)
  }
  v <- matrix(NA, n, m)
  nv <- rep(0,n)
  for (i in 1:n) {
    nv[i] <- sqrt(sum(x[i,]^2))
    v[i,] <- x[i,]/nv[i]
  }
  return(v)
}
